//FlashCannon.cs

//audio
datablock AudioProfile(FlashCannonShotSound)
{
   filename    = "./LaserCannonShot.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(FlashCannonHitSound)
{
   filename    = "./LaserCannonHit.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(FlashCannonExplodeSound)
{
   filename    = "./LaserCannonExplode.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(FlashCannonChargeSound)
{
   filename    = "./LaserCannonCharge.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock DebrisData(FlashCannonDebris)
{
	shapeFile = "./FlashCannon.dts";
	lifetime = 5.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

//trail
datablock ParticleData(FlashCannonTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 150;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= " ";

	// Interpolation variables
	colors[0]	= "0 1 1 1";
	colors[1]	= "0.5 1 1 0.4";
	sizes[0]	= 0.4;
	sizes[1]	= 0.5;
	//times[0]	= 0.5;
	//times[1]	= 0.5;
};

datablock ParticleData(FlashCannonChargedTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 500;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= " ";

	// Interpolation variables
	colors[0]	= "0.5 1 1 1";
	colors[1]	= "0 1 1 0.4";
	sizes[0]	= 1.2;
	sizes[1]	= 1.6;
	//times[0]	= 0.5;
	//times[1]	= 0.5;
};

datablock ParticleEmitterData(FlashCannonTrailEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = FlashCannonTrailParticle;

   useEmitterColors = true;
   uiName = "";
};

datablock ParticleEmitterData(FlashCannonChargedTrailEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = FlashCannonTrailParticle;

   useEmitterColors = true;
   uiName = "";
};

//muzzle flash effects
datablock ParticleData(FlashCannonFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0 1 1 0.9";
	colors[1]     = "0.4 0.7 0.7 0.0";
	sizes[0]      = 0.8;
	sizes[1]      = 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(FlashCannonFlashEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "FlashCannonFlashParticle";

   uiName = "";
};

datablock ParticleData(FlashCannonExplosionParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.6 0.9 0.9 0.9";
	colors[1]     = "0.5 0.6 0.9 0.0";
	sizes[0]      = 7.0;
	sizes[1]      = 10.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(FlashCannonExplosionEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 3.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "FlashCannonExplosionParticle";

   useEmitterColors = true;
   uiName = "";
};

datablock ParticleData(FlashCannonExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 40;
	lifetimeVarianceMS   = 10;
	textureName          = "base/data/particles/chunk";
	spinSpeed		= 2.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.75 0.75 0.5";
	colors[1]     = "0.5 0.3 0.0 0.0";
	sizes[0]      = 5;
	sizes[1]      = 9;

	useInvAlpha = false;
};
datablock ParticleEmitterData(FlashCannonExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 9;
   velocityVariance = 0.5;
   ejectionOffset   = 3.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 90;
   overrideAdvance = false;
   particles = "FlashCannonExplosionRingParticle";

   uiName = "";
};


datablock ExplosionData(FlashCannonExplosion)
{
   //explosionShape = "";
   explosionShape = "Add-Ons/Weapon_Rocket_Launcher/explosionSphere1.dts";
	soundProfile = FlashCannonHitSound;

   lifeTimeMS = 150;

   particleEmitter = FlashCannonExplosionEmitter;
   particleDensity = 9;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 15;
   lightStartColor = ".4 1 1 1";
   lightEndColor = "0 0 0 0";

   damageRadius = 2;
   radiusDamage = 100;

   impulseRadius = 4;
   impulseForce = 4000;
};

datablock ExplosionData(FlashCannonChargedExplosion)
{
   //explosionShape = "";
   explosionShape = "Add-Ons/Weapon_Rocket_Launcher/explosionSphere1.dts";
	soundProfile = FlashCannonExplodeSound;

   lifeTimeMS = 150;

   particleEmitter = FlashCannonExplosionEmitter;
   particleDensity = 12;
   particleRadius = 0.5;

   emitter[0] = FlashCannonExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 15;
   lightEndRadius = 25;
   lightStartColor = ".2 1 1 1";
   lightEndColor = "0 0 0 0";

   damageRadius = 6;
   radiusDamage = 700;

   impulseRadius = 9;
   impulseForce = 5000;
};

datablock ExplosionData(FlashCannonBackfireExplosion)
{
   //explosionShape = "";
	soundProfile = FlashCannonHitSound;

   lifeTimeMS = 150;

   particleEmitter = FlashCannonExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.1;

   faceViewer     = true;
   explosionScale = ".5 .5 .5";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 7;
   lightStartColor = ".4 1 1 1";
   lightEndColor = "0 0 0 0";

   damageRadius = 2;
   radiusDamage = 20;

   impulseRadius = 3;
   impulseForce = 750;
};


AddDamageType("FlashCannon",   '<bitmap:add-ons/Weapon_FlashCannon/CI_FlashCannon> %1',    '%2 <bitmap:add-ons/Weapon_FlashCannon/CI_FlashCannon> %1',0.2,1);
datablock ProjectileData(FlashCannonProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 50;
   directDamageType    = $DamageType::FlashCannon;
   radiusDamageType    = $DamageType::FlashCannon;

   brickExplosionRadius = 2;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 30;
   brickExplosionMaxVolume = 30;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 60;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 750;
   verticalImpulse	  = 750;
   explosion           = FlashCannonExplosion;
   particleEmitter     = FlashCannonTrailEmitter;

   muzzleVelocity      = 70;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = True;
   lightRadius = 4.0;
   lightColor  = "0 0.75 0.75";

   uiName = "Flash Cannon Laser";
};

datablock ProjectileData(FlashCannonChargedProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 200;
   directDamageType    = $DamageType::FlashCannon;
   radiusDamageType    = $DamageType::FlashCannon;

   brickExplosionRadius = 7;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 50;
   brickExplosionMaxVolume = 400;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 600;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 1000;
   verticalImpulse	  = 1000;
   explosion           = FlashCannonChargedExplosion;
   particleEmitter     = FlashCannonChargedTrailEmitter;

   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = True;
   lightRadius = 6.0;
   lightColor  = "0 1 1";

   uiName = "";
};

datablock ProjectileData(FlashCannonBackfireProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 0;
   directDamageType    = $DamageType::FlashCannon;
   radiusDamageType    = $DamageType::FlashCannon;

   brickExplosionRadius = 1;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 20;
   brickExplosionMaxVolume = 20;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 40;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = FlashCannonBackfireExplosion;

   muzzleVelocity      = 120;
   velInheritFactor    = 1;
   explodeOnDeath = 1;

   armingDelay         = 0;
   lifetime            = 0;
   fadeDelay           = 4000;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 1.0;

   hasLight    = false;
   lightRadius = 4.0;
   lightColor  = "0 0.75 0.75";

   uiName = "";
};

//////////
// item //
//////////
datablock ItemData(FlashCannonItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./FlashCannon.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Flash Cannon";
	iconName = "./icon_FlashCannon";
	doColorShift = false;
	colorShiftColor = "1 1 1 1.000";

	 // Dynamic properties defined by the scripts
	image = FlashCannonImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(FlashCannonImage)
{
   // Basic Item properties
   shapeFile = "./FlashCannon.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = FlashCannonProjectile;
   projectileType = Projectile;

   	casing = FlashCannonDebris;
	shellExitDir        = "1.0 -3.0 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = False;
   colorShiftColor = FlashCannonItem.colorShiftColor;//"0.400 0.196 0 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.8;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Charge";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]			= "Charge";
	statetransitionOnTimeOut[2]	= "ChargeFull";
	stateTransitiononTriggerup[2]   = "Fire";
	stateWaitForTimeout[2]		= false;
	stateAllowImageChange[1]        = true;
	stateSound[2]			= FlashCannonChargeSound;
	stateTimeoutValue[2]		= 8;
	

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Reload";
	stateTimeoutValue[3]            = 0.9;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;
	stateEmitter[3]					= FlashCannonFlashEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateSound[3]					= FlashCannonShotSound;

	stateName[4]			= "ChargeFull";
	stateEmitter[4]			= FlashCannonFlashEmitter;
	stateEmitterNode[4]		= "muzzleNode";
	stateEmitterTime[4]		= 0.5;
	stateTimeoutValue[4]            = 0.5;
	stateWaitForTimeout[4]		= false;
	stateAllowImageChange[4]        = true;
	stateTransitionOnTimeout[4]     = "ChargeFull";
	stateTransitiononTriggerup[4]   = "ChargeFire";

	stateName[5]                    = "ChargeFire";
	stateTransitionOnTimeout[5]     = "Done";
	stateTimeoutValue[5]            = 0.2;
	stateFire[5]                    = true;
	stateAllowImageChange[5]        = false;
	stateSequence[5]                = "Fire";
	stateScript[5]                  = "onChargeFire";
	stateWaitForTimeout[5]			= true;
	stateEmitter[5]					= FlashCannonFlashEmitter;
	stateEmitterTime[5]				= 0.05;
	stateEmitterNode[5]				= "muzzleNode";
	stateSound[5]					= FlashCannonShotSound;

	stateName[6]			= "Reload";
	stateSequence[6]                = "Reload";
	stateTimeoutValue[3]            = 1.2;
	stateTransitionOntimeout[6]   = "Ready";
	stateSequence[6]	        = "Ready";

	stateName[7]					= "Done";
	stateEjectShell[7]       			= true;
	stateScript[7]					= "onDone";

};

function FlashCannonImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, shiftAway);
		%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.client.player.getEyeVector(),"-4")));
	Parent::onFire(%this,%obj,%slot);	
}

function FlashCannonImage::onChargeFire(%this,%obj,%slot)
{
	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
		return;
	%obj.lastFireTime = getSimTime();
	%obj.lastFlashCannonSlot = %obj.currTool;
      
	%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.client.player.getEyeVector(),"-20")));
	%obj.playThread(2, shiftAway);

	%spread = 0;
	%shellcount = 1;


	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, FlashCannonChargedProjectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, FlashCannonChargedProjectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = FlashCannonChargedProjectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
	

}


function FlashCannonImage::onDone(%this,%obj,%slot)
{

	%p = new projectile()
	{
		dataBlock = FlashCannonBackFireProjectile;
		initialVelocity = "0 0 0";
		initialPosition = %obj.gettransform();
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
			
		
	MissionCleanup.add(%p);

	%obj.unMountImage(%slot);


	%currSlot = %obj.lastFlashCannonSlot;
	%obj.tool[%currSlot] = 0;
	%obj.weaponCount--;
	messageClient(%obj.client,'MsgItemPickup','',%currSlot,0);
	serverCmdUnUseTool(%obj.client);
}
